diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/ImprovedNoise.java b/game/core/src/main/java/net/minecraft/core/world/noise/ImprovedPerlinNoise.java
similarity index 82%
rename from game/core/src/main/java/net/minecraft/core/world/noise/ImprovedNoise.java
rename to game/core/src/main/java/net/minecraft/core/world/noise/ImprovedPerlinNoise.java
index 352940ae3..c46674408 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/ImprovedNoise.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/ImprovedPerlinNoise.java
@@ -1,24 +1,69 @@
 package net.minecraft.core.world.noise;
 
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
 // Derived from Ken Perlin's Improved Noise reference implementation: https://cs.nyu.edu/~perlin/noise/
-public class ImprovedNoise {
+public class ImprovedPerlinNoise
+    implements Noise3D {
+    public static @NotNull ImprovedPerlinNoise @NotNull [] genOctaves(final long seed, final int numOctaves) {
+        return genOctaves(seed, numOctaves, 0, LegacyNoiseType.DEFAULT);
+    }
+
+    public static @NotNull ImprovedPerlinNoise @NotNull [] genOctaves(final long seed, final int numOctaves, final int preOctaves) {
+        return genOctaves(seed, numOctaves, preOctaves, LegacyNoiseType.DEFAULT);
+    }
+
+    public static @NotNull ImprovedPerlinNoise @NotNull [] genOctaves(final long seed, final int numOctaves, final int preOctaves, final @NotNull LegacyNoiseType legacyNoiseType) {
+        final @NotNull Random random = new Random(seed);
+
+        for (int i = 0; i < preOctaves; i++) {
+            random.nextDouble();
+            random.nextDouble();
+            random.nextDouble();
+
+            for (int j = 0; j < 256; j++) {
+                random.nextInt(256 - j);
+            }
+        }
+
+        final @NotNull ImprovedPerlinNoise @NotNull [] octaves = new ImprovedPerlinNoise[numOctaves];
+        for (int i = 0; i < numOctaves; i++) {
+            octaves[i] = new ImprovedPerlinNoise(random, legacyNoiseType);
+        }
+
+        return octaves;
+    }
+
+    public enum LegacyNoiseType {
+        DEFAULT(true, true),
+        ALPHA(false, false),
+        BETA(true, false);
+
+        public final boolean handleEdgeCaseY;
+        public final boolean handleEdgeCaseZ;
+
+        LegacyNoiseType(final boolean handleEdgeCaseY, final boolean handleEdgeCaseZ) {
+            this.handleEdgeCaseY = handleEdgeCaseY;
+            this.handleEdgeCaseZ = handleEdgeCaseZ;
+        }
+    }
+
     private final @NotNull LegacyNoiseType legacyNoiseType;
 
     private final int @NotNull [] p;
-
     public final double xo;
     public final double yo;
+
     public final double zo;
 
-    public ImprovedNoise(final @NotNull Random random) {
+    public ImprovedPerlinNoise(final @NotNull Random random) {
         this(random, LegacyNoiseType.DEFAULT);
     }
 
-    public ImprovedNoise(final @NotNull Random random, final @NotNull LegacyNoiseType legacyNoiseType) {
+    public ImprovedPerlinNoise(final @NotNull Random random, final @NotNull LegacyNoiseType legacyNoiseType) {
         this.legacyNoiseType = legacyNoiseType;
 
         this.p = new int[512];
@@ -41,10 +86,12 @@ public class ImprovedNoise {
         }
     }
 
+    @Override
     public double getValue(final double x, final double z) {
         return this.getValue(x, z, 0);
     }
 
+    @Override
     public double getValue(double x, double y, double z) {
         // Find unit cube that contains point
         final int X = (int) Math.floor(x) & 255;
@@ -125,13 +172,29 @@ public class ImprovedNoise {
         return ((h & 1) == 0 ? u : -u) + ((h & 2) == 0 ? v : -v);
     }
 
-    public void add(
-        final double @NotNull [] out,
+    @Override
+    public double @NotNull [] addRegion(
+        final double @Nullable [] out,
+        final double x, final double z,
+        final int xSize, final int zSize,
+        final double xScale, final double zScale,
+        final double amplitude
+    ) {
+        return this.addRegion(out, x, z, 0, xSize, zSize, 1, xScale, zScale, 1.0, amplitude);
+    }
+
+    @Override
+    public double @NotNull [] addRegion(
+        double @Nullable [] out,
         final double x, final double y, final double z,
         final int xSize, final int ySize, final int zSize,
         final double xScale, final double yScale, final double zScale,
         final double amplitude
     ) {
+        if (out == null || out.length != xSize * ySize * zSize) {
+            out = new double[xSize * ySize * zSize];
+        }
+
         if (ySize == 1 && this.legacyNoiseType.handleEdgeCaseY) {
             int i = 0;
             for (int xi = 0; xi < xSize; xi++) {
@@ -320,5 +383,7 @@ public class ImprovedNoise {
                 }
             }
         }
+
+        return out;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/Noise2D.java b/game/core/src/main/java/net/minecraft/core/world/noise/Noise2D.java
new file mode 100644
index 000000000..ff74b3833
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/Noise2D.java
@@ -0,0 +1,31 @@
+package net.minecraft.core.world.noise;
+
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Arrays;
+
+public interface Noise2D {
+    double getValue(final double x, final double z);
+
+    double @NotNull [] addRegion(
+        final double @Nullable [] out,
+        final double x, final double z,
+        final int xSize, final int zSize,
+        final double xScale, final double zScale,
+        final double amplitude
+    );
+
+    default double @NotNull [] getRegion(
+        final double @Nullable [] out,
+        final double x, final double z,
+        final int xSize, final int zSize,
+        final double xScale, final double zScale
+    ) {
+        if (out != null) {
+            Arrays.fill(out, 0.0);
+        }
+
+        return this.addRegion(out, x, z, xSize, zSize, xScale, zScale, 1.0);
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/Noise3D.java b/game/core/src/main/java/net/minecraft/core/world/noise/Noise3D.java
new file mode 100644
index 000000000..94e3d969a
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/Noise3D.java
@@ -0,0 +1,32 @@
+package net.minecraft.core.world.noise;
+
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Arrays;
+
+public interface Noise3D
+    extends Noise2D {
+    double getValue(final double x, final double y, final double z);
+
+    double @NotNull [] addRegion(
+        final double @Nullable [] out,
+        final double x, final double y, final double z,
+        final int xSize, final int ySize, final int zSize,
+        final double xScale, final double yScale, final double zScale,
+        final double amplitude
+    );
+
+    default double @NotNull [] getRegion(
+        final double @Nullable [] out,
+        final double x, final double y, final double z,
+        final int xSize, final int ySize, final int zSize,
+        final double xScale, final double yScale, final double zScale
+    ) {
+        if (out != null) {
+            Arrays.fill(out, 0.0);
+        }
+
+        return this.addRegion(out, x, y, z, xSize, ySize, zSize, xScale, yScale, zScale, 1.0);
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/SimplexNoise.java b/game/core/src/main/java/net/minecraft/core/world/noise/SimplexNoise.java
index ce482f915..cd5dacad0 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/SimplexNoise.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/SimplexNoise.java
@@ -1,18 +1,48 @@
 package net.minecraft.core.world.noise;
 
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
-public class SimplexNoise {
+// Derived from https://github.com/SRombauts/SimplexNoise
+public class SimplexNoise
+    implements Noise2D, Noise3D {
+    public static @NotNull SimplexNoise @NotNull [] genOctaves(final long seed, final int numOctaves) {
+        return genOctaves(seed, numOctaves, 0);
+    }
+
+    public static @NotNull SimplexNoise @NotNull [] genOctaves(final long seed, final int numOctaves, final int preOctaves) {
+        final @NotNull Random random = new Random(seed);
+
+        for (int i = 0; i < preOctaves; i++) {
+            random.nextDouble();
+            random.nextDouble();
+            random.nextDouble();
+
+            for (int j = 0; j < 256; j++) {
+                random.nextInt(256 - j);
+            }
+        }
+
+        final @NotNull SimplexNoise @NotNull [] octaves = new SimplexNoise[numOctaves];
+        for (int i = 0; i < numOctaves; i++) {
+            octaves[i] = new SimplexNoise(random);
+        }
+
+        return octaves;
+    }
+
     private static final int @NotNull [] @NotNull [] GRAD = {
-        {  1,  1,  0 }, { -1,  1,  0 }, {  1, -1,  0 },
-        { -1, -1,  0 }, {  1,  0,  1 }, { -1,  0,  1 },
-        {  1,  0, -1 }, { -1,  0, -1 }, {  0,  1,  1 },
-        {  0, -1,  1 }, {  0,  1, -1 }, {  0, -1, -1 }
+        { 1, 1, 0 }, { -1, 1, 0 }, { 1, -1, 0 },
+        { -1, -1, 0 }, { 1, 0, 1 }, { -1, 0, 1 },
+        { 1, 0, -1 }, { -1, 0, -1 }, { 0, 1, 1 },
+        { 0, -1, 1 }, { 0, 1, -1 }, { 0, -1, -1 }
     };
-    private static final double F2 = 0.5D * (Math.sqrt(3D) - 1.0D);
-    private static final double G2 = (3D - Math.sqrt(3D)) / 6D;
+    private static final double F2 = 0.5 * (Math.sqrt(3.0) - 1.0);
+    private static final double G2 = (3.0 - Math.sqrt(3.0)) / 6.0;
+    private static final double F3 = 1.0 / 3.0;
+    private static final double G3 = 1.0 / 6.0;
 
     private final int @NotNull [] p;
     public final double xo;
@@ -21,9 +51,9 @@ public class SimplexNoise {
 
     public SimplexNoise(final @NotNull Random random) {
         this.p = new int[512];
-        this.xo = random.nextDouble() * 256D;
-        this.yo = random.nextDouble() * 256D;
-        this.zo = random.nextDouble() * 256D;
+        this.xo = random.nextDouble() * 256;
+        this.yo = random.nextDouble() * 256;
+        this.zo = random.nextDouble() * 256;
 
         for (int i = 0; i < 256; i++) {
             this.p[i] = i;
@@ -43,98 +73,282 @@ public class SimplexNoise {
     }
 
     private static double dot(final int @NotNull [] vec, final double x, final double y) {
-        return (double) vec[0] * x + (double) vec[1] * y;
+        return vec[0] * x + vec[1] * y;
+    }
+
+    private static double dot(final int @NotNull [] vec, final double x, final double y, final double z) {
+        return vec[0] * x + vec[1] * y + vec[2] * z;
+    }
+
+    @Override
+    public double getValue(final double x, final double z) {
+        // Skew the input space to determine which simplex cell we're in
+        final double s = (x + z) * F2;
+        final int i = fastFloor(x + s);
+        final int k = fastFloor(z + s);
+
+        // Unskew the cell origin back to (x, z) space
+        final double t = (i + k) * G2;
+        final double X0 = i - t;
+        final double Z0 = k - t;
+        final double x0 = x - X0;
+        final double z0 = z - Z0;
+
+        // For the 2D case, the simplex shape is an equilateral triangle.
+        // Determine which simplex we are in.
+
+        // Offsets for second (middle) corner of simplex in (i, k) coords
+        final int i1, k1;
+
+        if (x0 > z0) {
+            // Lower triangle, XZ order: (0, 0) -> (1, 0) -> (1, 1)
+            i1 = 1;
+            k1 = 0;
+        } else {
+            // Upper triangle, ZX order: (0, 0) -> (0, 1) -> (1, 1)
+            i1 = 0;
+            k1 = 1;
+        }
+
+        // A step of (1, 0) in (i, k) means a step of (1 - c, -c) in (x, z), and
+        // a step of (0, 1) in (i, k) means a step of (-c, 1 - c) in (x, z), where
+        // c = (3 - sqrt(3)) / 6
+
+        // Offsets for middle corner in (x, z) unskewed coords
+        final double x1 = (x0 - i1) + G2;
+        final double z1 = (z0 - k1) + G2;
+
+        // Offsets for last corner in (x, z) unskewed coords
+        final double x2 = (x0 - 1.0) + 2.0 * G2;
+        final double z2 = (z0 - 1.0) + 2.0 * G2;
+
+        // Work out the hashed gradient indices of the three simplex corners
+        final int ib = i & 0xFF;
+        final int kb = k & 0xFF;
+        final int gi0 = this.p[ib + this.p[kb]] % 12;
+        final int gi1 = this.p[ib + i1 + this.p[kb + k1]] % 12;
+        final int gi2 = this.p[ib + 1 + this.p[kb + 1]] % 12;
+
+        // Calculate the contribution from the first corner
+        double t0 = 0.5 - x0 * x0 - z0 * z0;
+        final double n0;
+        if (t0 < 0.0) {
+            n0 = 0.0;
+        } else {
+            t0 *= t0;
+            n0 = t0 * t0 * dot(GRAD[gi0], x0, z0);
+        }
+
+        // Calculate the contribution from the second corner
+        double t1 = 0.5 - x1 * x1 - z1 * z1;
+        final double n1;
+        if (t1 < 0.0) {
+            n1 = 0.0;
+        } else {
+            t1 *= t1;
+            n1 = t1 * t1 * dot(GRAD[gi1], x1, z1);
+        }
+
+        // Calculate the contribution from the third corner
+        double t2 = 0.5 - x2 * x2 - z2 * z2;
+        final double n2;
+        if (t2 < 0.0) {
+            n2 = 0.0;
+        } else {
+            t2 *= t2;
+            n2 = t2 * t2 * dot(GRAD[gi2], x2, z2);
+        }
+
+        return 70.0 * (n0 + n1 + n2);
     }
 
-    // Values generated are guaranteed to be between -1.0 and 1.0, multiplied by amplitude.
-    public void add(
-        final double @NotNull [] out,
-        final double xOffset, final double zOffset,
+    @Override
+    public double getValue(final double x, final double y, final double z) {
+        // Skew the input space to determine which simplex cell we're in
+        final double s = (x + y + z) * F3;
+        final int i = fastFloor(x + s);
+        final int j = fastFloor(y + s);
+        final int k = fastFloor(z + s);
+
+        // Unskew the cell origin back to (x, y, z) space
+        final double t = (i + j + k) * G3;
+        final double X0 = i - t;
+        final double Y0 = j - t;
+        final double Z0 = k - t;
+        final double x0 = x - X0;
+        final double y0 = y - Y0;
+        final double z0 = z - Z0;
+
+        // For the 3D case, the simplex shape is a slightly irregular tetrahedron.
+        // Determine which simplex we are in.
+
+        // Offsets for second corner of simplex in (i, j, k) coords
+        final int i1, j1, k1;
+
+        // Offsets for third corner of simplex in (i, j, k) coords
+        final int i2, j2, k2;
+
+        if (x0 >= y0) {
+            if (y0 >= z0) {
+                // X, Y, Z order
+                i1 = 1; j1 = 0; k1 = 0;
+                i2 = 1; j2 = 1; k2 = 0;
+            } else if (x0 >= z0) {
+                // X, Z, Y order
+                i1 = 1; j1 = 0; k1 = 0;
+                i2 = 1; j2 = 0; k2 = 1;
+            } else {
+                // Z, X, Y order
+                i1 = 0; j1 = 0; k1 = 1;
+                i2 = 1; j2 = 0; k2 = 1;
+            }
+        } else {
+            if (y0 < z0) {
+                // Z, Y, X order
+                i1 = 0; j1 = 0; k1 = 1;
+                i2 = 0; j2 = 1; k2 = 1;
+            } else if (x0 < z0) {
+                // Y, Z, X order
+                i1 = 0; j1 = 1; k1 = 0;
+                i2 = 0; j2 = 1; k2 = 1;
+            } else {
+                // Y, X, Z order
+                i1 = 0; j1 = 1; k1 = 0;
+                i2 = 1; j2 = 1; k2 = 0;
+            }
+        }
+
+        // A step of (1, 0, 0) in (i, j, k) means a step of (1 - c, -c, -c) in (x, y, z),
+        // a step of (0, 1, 0) in (i, j, k) means a step of (-c, 1 - c, -c) in (x, y, z), and
+        // a step of (0, 0, 1) in (i, j, k) means a step of (-c, -c, 1 - c) in (x, y, z), where
+        // c = 1/6.
+
+        // Offsets for second corner in (x, y, z) coords
+        final double x1 = x0 - i1 + G3;
+        final double y1 = y0 - j1 + G3;
+        final double z1 = z0 - k1 + G3;
+
+        // Offsets for third corner in (x, y, z) coords
+        final double x2 = x0 - i2 + 2.0 * G3;
+        final double y2 = y0 - j2 + 2.0 * G3;
+        final double z2 = z0 - k2 + 2.0 * G3;
+
+        // Offsets for last corner in (x, y, z) coords
+        final double x3 = x0 - 1.0 + 3.0 * G3;
+        final double y3 = y0 - 1.0 + 3.0 * G3;
+        final double z3 = z0 - 1.0 + 3.0 * G3;
+
+        // Work out the hashed gradient indices of the four simplex corners
+        final int ib = i & 0xFF;
+        final int jb = j & 0xFF;
+        final int kb = k & 0xFF;
+        final int gi0 = this.p[ib + this.p[jb + this.p[kb]]] % 12;
+        final int gi1 = this.p[ib + i1 + this.p[jb + j1 + this.p[kb + k1]]] % 12;
+        final int gi2 = this.p[ib + i2 + this.p[jb + j2 + this.p[kb + k2]]] % 12;
+        final int gi3 = this.p[ib + 1 + this.p[jb + 1 + this.p[kb + 1]]] % 12;
+
+        // Calculate the contribution from the first corner
+        double t0 = 0.6 - x0 * x0 - y0 * y0 - z0 * z0;
+        final double n0;
+        if (t0 < 0.0) {
+            n0 = 0.0;
+        } else {
+            t0 *= t0;
+            n0 = t0 * t0 * dot(GRAD[gi0], x0, y0, z0);
+        }
+
+        // Calculate the contribution from the second corner
+        double t1 = 0.6 - x1 * x1 - y1 * y1 - z1 * z1;
+        final double n1;
+        if (t1 < 0.0) {
+            n1 = 0.0;
+        } else {
+            t1 *= t1;
+            n1 = t1 * t1 * dot(GRAD[gi1], x1, y1, z1);
+        }
+
+        // Calculate the contribution from the third corner
+        double t2 = 0.6 - x2 * x2 - y2 * y2 - z2 * z2;
+        final double n2;
+        if (t2 < 0.0) {
+            n2 = 0.0;
+        } else {
+            t2 *= t2;
+            n2 = t2 * t2 * dot(GRAD[gi2], x2, y2, z2);
+        }
+
+        // Calculate the contribution from the fourth corner
+        double t3 = 0.6 - x3 * x3 - y3 * y3 - z3 * z3;
+        final double n3;
+        if (t3 < 0.0) {
+            n3 = 0.0;
+        } else {
+            t3 *= t3;
+            n3 = t3 * t3 * dot(GRAD[gi3], x3, y3, z3);
+        }
+
+        return 32.0 * (n0 + n1 + n2 + n3);
+    }
+
+    @Override
+    public double @NotNull [] addRegion(
+        double @Nullable [] out,
+        final double x, final double z,
         final int xSize, final int zSize,
-        final double xScale, final double zScale,
-        final double amplitude
+        double xScale, double zScale,
+        double amplitude
     ) {
-        int index = 0;
-        for (int dx = 0; dx < xSize; dx++) {
-            final double x = (xOffset + (double) dx) * xScale + this.xo;
-            for (int dz = 0; dz < zSize; dz++) {
-                final double z = (zOffset + (double) dz) * zScale + this.yo;
-
-                // Skew the input space to determine which simplex cell we're in
-                final double s = (x + z) * F2;
-                final int i = fastFloor(x + s);
-                final int j = fastFloor(z + s);
-
-                // Unskew the cell origin back to (x, z) space
-                final double t = (double) (i + j) * G2;
-                final double X0 = (double) i - t;
-                final double Z0 = (double) j - t;
-                final double x0 = x - X0;
-                final double z0 = z - Z0;
-
-                // For the 2D case, the simplex shape is an equilateral triangle.
-                // Determine which simplex we are in.
-                final int i1;  // Offsets for second (middle) corner of simplex in (i, j) coords
-                final int j1;
-                if (x0 > z0) // Lower triangle, XZ order: (0, 0) -> (1, 0) -> (1, 1)
-                {
-                    i1 = 1;
-                    j1 = 0;
-                } else // Upper triangle, ZX order: (0, 0) -> (0, 1) -> (1, 1)
-                {
-                    i1 = 0;
-                    j1 = 1;
-                }
+        if (out == null || out.length != xSize * zSize) {
+            out = new double[xSize * zSize];
+        }
 
-                // A step of (1, 0) in (i, j) means a step of (1 - c, -c) in (x, z), and
-                // a step of (0, 1) in (i, j) means a step of (-c, 1 - c) in (x, z), where
-                // c = (3 - sqrt(3)) / 6
-
-                final double x1 = (x0 - (double) i1) + G2; // Offsets for middle corner in (x, z) unskewed coords
-                final double z1 = (z0 - (double) j1) + G2;
-                final double x2 = (x0 - 1.0D) + 2D * G2;  // Offsets for last corner in (x, z) unskewed coords
-                final double z2 = (z0 - 1.0D) + 2D * G2;
-
-                // Work out the hashed gradient indices of the three simplex corners
-                final int ib = i & 0xff;
-                final int jb = j & 0xff;
-                final int gi0 = this.p[ib + this.p[jb]] % 12;
-                final int gi1 = this.p[ib + i1 + this.p[jb + j1]] % 12;
-                final int gi2 = this.p[ib + 1 + this.p[jb + 1]] % 12;
-
-                // Calculate the contribution from the first corner
-                double t0 = 0.5D - x0 * x0 - z0 * z0;
-                final double n0;
-                if (t0 < 0.0D) {
-                    n0 = 0.0D;
-                } else {
-                    t0 *= t0;
-                    n0 = t0 * t0 * dot(GRAD[gi0], x0, z0);
-                }
+        xScale /= 1.5;
+        zScale /= 1.5;
+        amplitude *= 0.55;
 
-                // Calculate the contribution from the second corner
-                double t1 = 0.5D - x1 * x1 - z1 * z1;
-                final double n1;
-                if (t1 < 0.0D) {
-                    n1 = 0.0D;
-                } else {
-                    t1 *= t1;
-                    n1 = t1 * t1 * dot(GRAD[gi1], x1, z1);
-                }
+        int i = 0;
+        for (int xi = 0; xi < xSize; xi++) {
+            final double xx = (x + xi) * xScale + this.xo;
+            for (int zi = 0; zi < zSize; zi++) {
+                final double zz = (z + zi) * zScale + this.yo;
 
-                // Calculate the contribution from the third corner
-                double t2 = 0.5D - x2 * x2 - z2 * z2;
-                final double n2;
-                if (t2 < 0.0D) {
-                    n2 = 0.0D;
-                } else {
-                    t2 *= t2;
-                    n2 = t2 * t2 * dot(GRAD[gi2], x2, z2);
-                }
+                out[i++] += this.getValue(xx, zz) * amplitude;
+            }
+        }
 
-                final double value = 70 * (n0 + n1 + n2);
-                out[index++] += value * amplitude;
+        return out;
+    }
+
+    @Override
+    public double @NotNull [] addRegion(
+        double @Nullable [] out,
+        final double x, final double y, final double z,
+        final int xSize, final int ySize, final int zSize,
+        double xScale, double yScale, double zScale,
+        double amplitude
+    ) {
+        if (out == null || out.length != xSize * ySize * zSize) {
+            out = new double[xSize * ySize * zSize];
+        }
+
+        xScale /= 1.5;
+        yScale /= 1.5;
+        zScale /= 1.5;
+        amplitude *= 0.55;
+
+        int i = 0;
+        for (int xi = 0; xi < xSize; xi++) {
+            final double xx = (x + xi) * xScale + this.xo;
+            for (int zi = 0; zi < zSize; zi++) {
+                final double zz = (z + zi) * zScale + this.zo;
+                for (int yi = 0; yi < ySize; yi++) {
+                    final double yy = (y + yi) * yScale + this.yo;
+
+                    out[i++] = this.getValue(xx, yy, zz) * amplitude;
+                }
             }
         }
+
+        return out;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/operator/Constant2D.java b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Constant2D.java
new file mode 100644
index 000000000..7a2ee024a
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Constant2D.java
@@ -0,0 +1,38 @@
+package net.minecraft.core.world.noise.operator;
+
+import net.minecraft.core.world.noise.Noise2D;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Arrays;
+
+public class Constant2D
+    implements Noise2D {
+    protected final double value;
+
+    public Constant2D(final double value) {
+        this.value = value;
+    }
+
+    @Override
+    public double getValue(final double x, final double z) {
+        return this.value;
+    }
+
+    @Override
+    public double @NotNull [] addRegion(
+        double @Nullable [] out,
+        final double x, final double z,
+        final int xSize, final int zSize,
+        final double xScale, final double zScale,
+        final double amplitude
+    ) {
+        if (out == null || out.length < xSize * zSize) {
+            out = new double[xSize * zSize];
+        }
+
+        Arrays.fill(out, this.value);
+
+        return out;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/operator/Constant3D.java b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Constant3D.java
new file mode 100644
index 000000000..5f821e403
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Constant3D.java
@@ -0,0 +1,37 @@
+package net.minecraft.core.world.noise.operator;
+
+import net.minecraft.core.world.noise.Noise3D;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Arrays;
+
+public class Constant3D
+    extends Constant2D
+    implements Noise3D {
+    public Constant3D(final double value) {
+        super(value);
+    }
+
+    @Override
+    public double getValue(final double x, final double y, final double z) {
+        return this.value;
+    }
+
+    @Override
+    public double @NotNull [] addRegion(
+        double @Nullable [] out,
+        final double x, final double y, final double z,
+        final int xSize, final int ySize, final int zSize,
+        final double xScale, final double yScale, final double zScale,
+        final double amplitude
+    ) {
+        if (out == null || out.length != xSize * ySize * zSize) {
+            out = new double[xSize * ySize * zSize];
+        }
+
+        Arrays.fill(out, this.value);
+
+        return out;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/operator/Emboss2D.java b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Emboss2D.java
new file mode 100644
index 000000000..170772571
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Emboss2D.java
@@ -0,0 +1,41 @@
+package net.minecraft.core.world.noise.operator;
+
+import net.minecraft.core.world.noise.Noise2D;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public class Emboss2D<T extends Noise2D>
+    implements Noise2D {
+    protected final @NotNull T noise;
+
+    public Emboss2D(final @NotNull T noise) {
+        this.noise = noise;
+    }
+
+    @Override
+    public double getValue(final double x, final double z) {
+        return this.noise.getValue(x, z) - this.noise.getValue(x + 1.0, z + 1.0);
+    }
+
+    @Override
+    public double @NotNull [] addRegion(
+        double @Nullable [] out,
+        final double x, final double z,
+        final int xSize, final int zSize,
+        final double xScale, final double zScale,
+        final double amplitude
+    ) {
+        if (out == null || out.length < xSize * zSize) {
+            out = new double[xSize * zSize];
+        }
+
+        final double @NotNull [] valuesA = this.noise.addRegion(null, x, z, xSize, zSize, xScale, zScale, amplitude);
+        final double @NotNull [] valuesB = this.noise.addRegion(null, x + 1.0, z + 1.0, xSize, zSize, xScale, zScale, amplitude);
+
+        for (int i = 0; i < out.length; i++) {
+            out[i] += valuesA[i] - valuesB[i];
+        }
+
+        return out;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/operator/Emboss3D.java b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Emboss3D.java
new file mode 100644
index 000000000..196fc3511
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Emboss3D.java
@@ -0,0 +1,40 @@
+package net.minecraft.core.world.noise.operator;
+
+import net.minecraft.core.world.noise.Noise3D;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public class Emboss3D<T extends Noise3D>
+    extends Emboss2D<T>
+    implements Noise3D {
+    public Emboss3D(@NotNull final T noise) {
+        super(noise);
+    }
+
+    @Override
+    public double getValue(final double x, final double y, final double z) {
+        return this.noise.getValue(x, y, z) - this.noise.getValue(x + 1.0, y + 1.0, z + 1.0);
+    }
+
+    @Override
+    public double @NotNull [] addRegion(
+        double @Nullable [] out,
+        final double x, final double y, final double z,
+        final int xSize, final int ySize, final int zSize,
+        final double xScale, final double yScale, final double zScale,
+        final double amplitude
+    ) {
+       if (out == null || out.length < xSize * ySize * zSize) {
+           out = new double[xSize * ySize * zSize];
+       }
+
+       final double @NotNull [] valuesA = this.noise.addRegion(null, x, y, z, xSize, ySize, zSize, xScale, yScale, zScale, amplitude);
+       final double @NotNull [] valuesB = this.noise.addRegion(null, x + 1.0, y + 1.0, z + 1.0, xSize, ySize, zSize, xScale, yScale, zScale, amplitude);
+
+       for (int i = 0; i < out.length; i++) {
+           out[i] += valuesA[i] - valuesB[i];
+       }
+
+       return out;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/operator/Rotate2D.java b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Rotate2D.java
new file mode 100644
index 000000000..c0cb028a1
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Rotate2D.java
@@ -0,0 +1,35 @@
+package net.minecraft.core.world.noise.operator;
+
+import net.minecraft.core.world.noise.Noise2D;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public class Rotate2D<T extends Noise2D>
+    implements Noise2D {
+    protected final @NotNull T noise;
+    protected final double sin;
+    protected final double cos;
+
+    public Rotate2D(final @NotNull T noise, final double yRot) {
+        this.noise = noise;
+
+        this.sin = Math.sin(yRot);
+        this.cos = Math.cos(yRot);
+    }
+
+    @Override
+    public double getValue(final double x, final double z) {
+        return this.noise.getValue(x * this.cos + z * this.sin, z * this.cos - x * this.sin);
+    }
+
+    @Override
+    public double @NotNull [] addRegion(
+        final double @Nullable [] out,
+        final double x, final double z,
+        final int xSize, final int zSize,
+        final double xScale, final double zScale,
+        final double amplitude
+    ) {
+        throw new UnsupportedOperationException("Not implemented!");
+    }
+}
